﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

[System.Serializable]
public class DialogueInfo
{
    public DialogueInfo()
    {

    }

    public List<Sprite> dialogue_box;
    public List<Sprite> dialogue_art;
}

public class BossHpMilestones : MonoBehaviour
{
    [SerializeField] private EndingBehaviour endingBehaviour = null;

    [SerializeField] private IntVariable bossHp = null;
    [SerializeField] private IntVariable maxHp = null;

    [SerializeField] private DialogueFading dialogue_parent = null;
    [SerializeField] private Image spriteBox = null;
    [SerializeField] private Image dialogueBox = null;

    [SerializeField] private List<DialogueInfo> dialogueInfo = new List<DialogueInfo>();

    //[SerializeField] private List<Sprite> milestone_sprites = new List<Sprite>();

    //[SerializeField] private List<Sprite> dialogue_milestoneStart = new List<Sprite>();
    //[SerializeField] private List<Sprite> dialogue_milestone1 = new List<Sprite>();
    //[SerializeField] private List<Sprite> dialogue_milestone2 = new List<Sprite>();
    //[SerializeField] private List<Sprite> dialogue_milestone3 = new List<Sprite>();
    //[SerializeField] private List<Sprite> dialogue_milestone4 = new List<Sprite>();
    
    private float milestone1 = 0.25f;
    private float milestone2 = 0.50f;
    private float milestone3 = 0.75f;
    private float milestone4 = 1.0f;

    public enum Milestone
    {
        Start,
        One,
        Two,
        Three,
        Four,
        Done
    }
    public Milestone currentMilestone = Milestone.Start;

    private int currentIndex = 0;

    public static bool interactable = false;

    public System.Action OnEndScreen;

    private void OnEnable()
    {
        currentMilestone = Milestone.Start;
        currentIndex = 0;
        interactable = true;

        spriteBox.sprite = dialogueInfo[0].dialogue_art[0];/* milestone_sprites[0];*/
        //spriteBox.gameObject.SetActive(true);

        //dialogueBox.gameObject.SetActive(true);
        dialogueBox.sprite = dialogueInfo[0].dialogue_box[0]; /*dialogue_milestoneStart[0];*/

        //dialogue_parent.SetActive(true);
        //dialogue_parent.Activate();
    }

    private void Update()
    {
        if (!interactable)
        {
            float x = bossHp.Variable;
            float y = maxHp.Variable;
            float t = x / y;

            // Check milestones
            if (t >= milestone1 && currentMilestone == Milestone.One)
            {
                currentIndex = 0;
                interactable = true;

                spriteBox.sprite = dialogueInfo[1].dialogue_art[0];
                //spriteBox.gameObject.SetActive(true);

                //dialogueBox.gameObject.SetActive(true);
                dialogueBox.sprite = dialogueInfo[1].dialogue_box[0];

                //dialogue_parent.SetActive(true);
                dialogue_parent.Activate();
            }
            else if (t >= milestone2 && currentMilestone == Milestone.Two)
            {
                currentIndex = 0;
                interactable = true;

                spriteBox.sprite = dialogueInfo[2].dialogue_art[0];
                //spriteBox.gameObject.SetActive(true);

                //dialogueBox.gameObject.SetActive(true);
                dialogueBox.sprite = dialogueInfo[2].dialogue_box[0];

                //dialogue_parent.SetActive(true);
                dialogue_parent.Activate();
            }
            else if (t >= milestone3 && currentMilestone == Milestone.Three)
            {
                currentIndex = 0;
                interactable = true;

                spriteBox.sprite = dialogueInfo[3].dialogue_art[0];
                //spriteBox.gameObject.SetActive(true);

                //dialogueBox.gameObject.SetActive(true);
                dialogueBox.sprite = dialogueInfo[3].dialogue_box[0];

                //dialogue_parent.SetActive(true);
                dialogue_parent.Activate();
            }
            else if (t >= milestone4 && currentMilestone == Milestone.Four)
            {
                currentIndex = 0;
                interactable = true;

                spriteBox.sprite = dialogueInfo[4].dialogue_art[0];
                //spriteBox.gameObject.SetActive(true);

                //dialogueBox.gameObject.SetActive(true);
                dialogueBox.sprite = dialogueInfo[4].dialogue_box[0];

                //dialogue_parent.SetActive(true);
                dialogue_parent.Activate();
            }
        }
        else if (interactable)
        {
            if (Input.GetKeyDown(KeyCode.Space))
            {
                MoveNext();
            }
        }
    }

    void MoveNext()
    {
        currentIndex++;
        switch(currentMilestone)
        {
            case Milestone.Start:
                if (currentIndex >= dialogueInfo[0].dialogue_box.Count)
                {
                    currentMilestone = Milestone.One;
                    //spriteBox.gameObject.SetActive(false);
                    //dialogueBox.gameObject.SetActive(false);
                    //dialogue_parent.SetActive(false);
                    dialogue_parent.Deactivate();
                    interactable = false;
                }
                else
                {
                    dialogueBox.sprite = dialogueInfo[0].dialogue_box[currentIndex];
                    spriteBox.sprite = dialogueInfo[0].dialogue_art[currentIndex];
                }
                break;
            case Milestone.One:
                if (currentIndex >= dialogueInfo[1].dialogue_box.Count)
                {
                    currentMilestone = Milestone.Two;
                    //spriteBox.gameObject.SetActive(false);
                    //dialogueBox.gameObject.SetActive(false);
                    //dialogue_parent.SetActive(false);
                    dialogue_parent.Deactivate();
                    interactable = false;
                }
                else
                {
                    dialogueBox.sprite = dialogueInfo[1].dialogue_box[currentIndex];
                    spriteBox.sprite = dialogueInfo[1].dialogue_art[currentIndex];
                }
                break;
            case Milestone.Two:
                if (currentIndex >= dialogueInfo[2].dialogue_box.Count)
                {
                    currentMilestone = Milestone.Three;
                    //spriteBox.gameObject.SetActive(false);
                    //dialogueBox.gameObject.SetActive(false);
                    //dialogue_parent.SetActive(false);
                    dialogue_parent.Deactivate();
                    interactable = false;
                }
                else
                {
                    dialogueBox.sprite = dialogueInfo[2].dialogue_box[currentIndex];
                    spriteBox.sprite = dialogueInfo[2].dialogue_art[currentIndex];
                }
                break;
            case Milestone.Three:
                if (currentIndex >= dialogueInfo[3].dialogue_box.Count)
                {
                    currentMilestone = Milestone.Four;
                    //spriteBox.gameObject.SetActive(false);
                    //dialogueBox.gameObject.SetActive(false);
                    //dialogue_parent.SetActive(false);
                    dialogue_parent.Deactivate();
                    interactable = false;
                }
                else
                {
                    dialogueBox.sprite = dialogueInfo[3].dialogue_box[currentIndex];
                    spriteBox.sprite = dialogueInfo[3].dialogue_art[currentIndex];
                }
                break;
            case Milestone.Four:
                if (currentIndex >= dialogueInfo[4].dialogue_box.Count)
                {
                    currentMilestone = Milestone.Done;
                    endingBehaviour.Ending();
                    OnEndScreen?.Invoke();
                    //spriteBox.gameObject.SetActive(false);
                    //dialogueBox.gameObject.SetActive(false);
                    //dialogue_parent.SetActive(false);
                    //dialogue_parent.Deactivate();
                    //interactable = false;
                }
                else
                {
                    dialogueBox.sprite = dialogueInfo[4].dialogue_box[currentIndex];
                    spriteBox.sprite = dialogueInfo[4].dialogue_art[currentIndex];
                }
                break;
        }
    }
}
