﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class EndingBehaviour : MonoBehaviour
{
    [SerializeField] private Image endScreenSprite = null;

    [SerializeField] private CanvasGroup canvasGroup = null;
    [SerializeField] private CanvasGroup endScrenFader = null;

    private float mTimer = 0;
    private bool check = false;

    bool interactable = false;

    private void Awake()
    {
        canvasGroup.alpha = 0;
        endScrenFader.alpha = 0;
    }

    private void Update()
    {
        if (!interactable)
            return;

        if (Input.GetKeyDown(KeyCode.Return))
        {
            interactable = false;
            StartCoroutine(FadeOut());
        }


        if (check)
        {
            mTimer += Time.deltaTime;
        }
        if (mTimer > 20)
        {
            SceneManager.LoadScene("SampleScene");
        }
    }

    public void Ending()
    {
        endScreenSprite.gameObject.SetActive(true);

        StartCoroutine(FadeIn());
        check = true;

    }

    IEnumerator FadeIn()
    {
        float timer = 0;
        while (timer < 0.5f)
        {
            timer += Time.deltaTime;
            float t = timer / 0.5f;

            canvasGroup.alpha = t;

            yield return null;
        }
        interactable = true;
        canvasGroup.alpha = 1;
    }

    IEnumerator FadeOut()
    {
        float timer = 0;
        while (timer < 4f)
        {
            timer += Time.deltaTime;
            float t = timer / 4f;

            endScrenFader.alpha = t;

            yield return null;
        }
        canvasGroup.alpha = 1;
    }
}
