﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
[System.Serializable]
public class PlayerShooting : MonoBehaviour
{
    public GameObject shot = null;
    public List<GameObject> shotPool = null;
    public int poolCount = 10;
    public Transform poolParent = null;
    public IntVariable playerHP;

    public float shotInterval = 0.1f;
    float shotTimer = 0.0f;

    public AudioSource audioSource = null;
    public AudioClip audioClip = null;

    // Start is called before the first frame update
    void Start()
    {
        playerHP.Variable = 9;
    }

    public void InitPhase()
    {
        for (int i = 0; i < poolCount; i++)
        {
            Add(shot, poolParent);
        }
    }

    public void Add(GameObject gameObject, Transform parent)
    {
        //if (shot == null) // Remember what object is in the pool
        //{
        //    shot = gameObject;
        //}

        GameObject newObject = MonoBehaviour.Instantiate(gameObject, new Vector2(200, 0), Quaternion.identity, parent);
        newObject.SetActive(false);
        shotPool.Add(newObject); // Add the object to the pool
    }

    public GameObject GetAvailable() // Return an available gameobject
    {
        for (int i = 0; i < shotPool.Count; i++)
        {
            if (!shotPool[i].activeInHierarchy)
            {
                return shotPool[i];
            }
        }

        GameObject newObject = MonoBehaviour.Instantiate(shot, new Vector2(200, 0), Quaternion.identity, poolParent); // Spawn new object and add it to the list
        shotPool.Add(newObject);

        return newObject;
    }

    // Update is called once per frame
    void Update()
    {
        if (!BossHpMilestones.interactable)
        {
            if (shotInterval < shotTimer)
            {
                if (Input.GetAxis("Shoot") != 0)
                {
                    audioSource.PlayOneShot(audioClip);

                    if (Input.GetAxis("Strafe") != 0)
                    {
                        GameObject shot = GetAvailable();
                        shot.transform.position = transform.position + new Vector3(0.7f, 0.4f, 0.0f);
                        shot.transform.rotation = transform.rotation;
                        shot.SetActive(true);
                        shot = GetAvailable();
                        shot.transform.position = transform.position + new Vector3(0.25f, 0.7f, 0.0f);
                        shot.transform.rotation = transform.rotation;
                        shot.SetActive(true);
                        shot = GetAvailable();
                        shot.transform.position = transform.position + new Vector3(-0.25f, 0.7f, 0.0f);
                        shot.transform.rotation = transform.rotation;
                        shot.SetActive(true);
                        shot = GetAvailable();
                        shot.transform.position = transform.position + new Vector3(-0.7f, 0.4f, 0.0f);
                        shot.transform.rotation = transform.rotation;
                        shot.SetActive(true);
                        shotTimer = 0.0f;
                    }
                    else
                    {

                        GameObject shot = GetAvailable();
                        shot.transform.position = transform.position + new Vector3(1.0f, 0.0f, 0.0f);
                        shot.transform.rotation = transform.rotation;
                        shot.SetActive(true);
                        shot = GetAvailable();
                        shot.transform.position = transform.position + new Vector3(0.4f, 0.5f, 0.0f);
                        shot.transform.rotation = transform.rotation;
                        shot.SetActive(true);
                        shot = GetAvailable();
                        shot.transform.position = transform.position + new Vector3(-0.4f, 0.5f, 0.0f);
                        shot.transform.rotation = transform.rotation;
                        shot.SetActive(true);
                        shot = GetAvailable();
                        shot.transform.position = transform.position + new Vector3(-1.0f, 0.0f, 0.0f);
                        shot.transform.rotation = transform.rotation;
                        shot.SetActive(true);
                        shotTimer = 0.0f;
                    }
                }
            }
            else
            {
                shotTimer += Time.deltaTime;
            }
        }
    }
}
