﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ArrowBehaviour : MonoBehaviour
{
    [SerializeField] private RectTransform rightArrow = null;
    [SerializeField] private RectTransform leftArrow = null;
    [SerializeField] private AnimationCurve animCurve = null;

    private Vector3 rightStartPos;
    private Vector3 leftStartPos;

    private float timer = 0;

    private void Start()
    {
        rightStartPos = rightArrow.localPosition;
        leftStartPos = leftArrow.localPosition;
    }

    void Update()
    {
        timer += Time.deltaTime;
        float t = animCurve.Evaluate(timer / 2);

        leftArrow.localPosition = leftStartPos + (leftArrow.right * t);
        rightArrow.localPosition = rightStartPos + (rightArrow.right * t);

        if (timer > 2)
        {
            timer = 0;
        }
    }
}
