﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class DialogueFading : MonoBehaviour
{
    public CanvasGroup canvasGroup = null;

    public void Activate()
    {
        StartCoroutine(FadeIn());
    }

    public void Deactivate()
    {
        StartCoroutine(FadeOut());
    }

    IEnumerator FadeIn()
    {
        float timer = 0;
        while (timer < 0.5f)
        {
            timer += Time.deltaTime;
            float t = timer / 0.5f;

            canvasGroup.alpha = t;

            yield return null;
        }
        canvasGroup.alpha = 1;
    }

    IEnumerator FadeOut()
    {
        float timer = 0;
        while (timer < 0.5f)
        {
            timer += Time.deltaTime;
            float t = 1 - (timer / 0.5f);

            canvasGroup.alpha = t;

            yield return null;
        }
        canvasGroup.alpha = 0;
    }
}
